#include <bits/stdc++.h>
using namespace std;


int main()
{
    int w,h,r,q,ind,x,y;
    cin>>w>>h>>r>>q;
    if(r==1) {
        bool a[w+1]; for(int i=0; i<=w; ++i) a[i]=false;
        while(q--) {
            cin>>ind;
            if(ind==1) {
                cin>>x>>y;
                if(y==h) a[x]=true;
            }
            else {
                cin>>x;
                if(a[x]) printf("%d.000000000\n",h-1);
                else printf("%d.000000000\n",h);
            }
        }
    }
    else {
        while(q--) {
            cin>>ind;
            if(ind==1) cin>>x>>y;
            else {
                cin>>x;
                printf("%d.000000000\n",h);
            }
        }
    }
}